<?xml version="1.0"  encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects. 
======================================================================= -->
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xalan="http://xml.apache.org/xalan"
	xmlns:redirect="http://xml.apache.org/xalan/redirect"
  	extension-element-prefixes="redirect">


    <xsl:include href="dynamics-report-standard-analysis-defined-metrics.xsl"/>
    <xsl:include href="dynamics-report-standard-analysis-source-control.xsl"/>
    <xsl:include href="dynamics-report-standard-analysis-size.xsl"/>
    <xsl:include href="dynamics-report-standard-analysis-code-quality.xsl"/>
    <xsl:include href="dynamics-report-standard-analysis-test.xsl"/>
    <xsl:include href="dynamics-report-standard-analysis-package-design.xsl"/>
    <xsl:include href="dynamics-report-standard-analysis-architecture.xsl"/>
    <xsl:include href="dynamics-report-standard-analysis-documentation.xsl"/>    
    <xsl:include href="../../../system/radar/dynamics/report/dynamics-report-system-specific-analysis.xsl"/>

<xsl:template name="standard-analysis-overview">
	<xsl:param name="reports-element"/>
   	<xsl:param name="defined-metrics-element"/>
	<xsl:param name="defined-metrics-elements-subcomponents"/>
	<xsl:param name="packages-element"/>   
	<xsl:param name="subsystem-name"/>
	<xsl:param name="single-package"/>
	<xsl:param name="package-element"/>
   	<xsl:param name="page-type" select="''"/>
<!--  
	<xsl:message>
report-element:<xsl:value-of select="$reports-element"/>	
defined-metrics-element:<xsl:value-of select="$defined-metrics-element"/>
defined-metrics-elements-subcomponents:<xsl:value-of select="$defined-metrics-elements-subcomponents"/>
packages-element:<xsl:value-of select="$packages-element"/>
subsystem-name:<xsl:value-of select="$subsystem-name"/>
single-package:<xsl:value-of select="$single-package"/>
package-element:<xsl:value-of select="$package-element"/>
page-type:<xsl:value-of select="$page-type"/>
	</xsl:message> -->

   	<html>
	<head>
         <link rel="stylesheet" type="text/css" href="../stylesheet.css"/>
<script type="text/javascript" LANGUAGE="JavaScript">			
function winpopanalysisdetails(loc){
Hwnd=window.open(loc,"Radar",'height=750,width=750,top=25,left=75,toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=yes,resizable=1');
if (Hwnd.focus != null) Hwnd.focus();
}				
</script>	
	</head>
    <body>
         
    	<xsl:call-template name="page-header">
  	  	   <xsl:with-param name="page-name">
  	  	   	<xsl:choose>
	         	<xsl:when test="$single-package='true'">
	         		<xsl:value-of select="concat($page-type,' - ',/radar-report/@system,' : ', $package-element/@name)"/>
	         	</xsl:when>
                <xsl:when test="not($subsystem-name)">
	         		<h2><xsl:value-of select="concat($page-type,' - ',/radar-report/@system)"/></h2>
	         	</xsl:when>
	         	<xsl:otherwise>
	       			<xsl:value-of select="concat($page-type,' - ',/radar-report/@system,' : ',$subsystem-name)"/>
	         	</xsl:otherwise>
	         </xsl:choose>
	       </xsl:with-param>
           <xsl:with-param name="main-menu-page-name" select="'scorecard'"/>
           <xsl:with-param name="page-type"  select="$page-type"/>
            <xsl:with-param name="statics-page-name">
  	  	   	<xsl:choose>
	         	<xsl:when test="$page-type='code and duplication'">code</xsl:when>
	         	<xsl:when test="$page-type='system specific'">system-specific</xsl:when>
	         	<xsl:when test="$page-type='source control'">source-control</xsl:when>
	         	<xsl:otherwise><xsl:value-of select="$page-type"/></xsl:otherwise>
	         </xsl:choose>
	       </xsl:with-param>
            <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
		    <xsl:with-param name="single-package" select="$single-package"/>
            <xsl:with-param name="package-name">
                <xsl:choose>
                    <xsl:when test="$single-package='true'"><xsl:value-of select="$package-element/@name"/></xsl:when>
                    <xsl:otherwise></xsl:otherwise>
                </xsl:choose>
            </xsl:with-param>
  	    </xsl:call-template>



        <hr size="1"/>

        <xsl:choose>
            <xsl:when test="$page-type = 'overview'">
            <!-- 
            	<xsl:message>
Calling 'standard-analysis-defined-metrics' for page-type <xsl:value-of select="$page-type"/>
<xsl:for-each select="$defined-metrics-element/metric">
	metric:<xsl:value-of select="."/>
</xsl:for-each>
            	</xsl:message> -->
                <xsl:call-template name="standard-analysis-defined-metrics">
                   <xsl:with-param name="defined-metrics-element" select="$defined-metrics-element"/>
				   <xsl:with-param name="defined-metrics-elements-subcomponents" select="$defined-metrics-elements-subcomponents"/>	
                   <xsl:with-param name="reports-element" select="$reports-element"/>
                   <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                    <xsl:with-param name="package-element" select="$package-element"/>
                </xsl:call-template>
		    </xsl:when>



            <xsl:when test="$page-type = 'architecture'">
                <xsl:if test="((not($single-package = 'true')) and ($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/package-oo-metrics/distance)) or
                                    (($single-package = 'true') and ($package-element/statistics/package-oo-metrics/distance))">
                    <xsl:call-template name="standard-analysis-architecture">
                       <xsl:with-param name="reports-element" select="$reports-element"/>
                       <xsl:with-param name="packages-element" select="$packages-element"/>
                       <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                       <xsl:with-param name="single-package" select="$single-package"/>
                       <xsl:with-param name="package-element" select="$package-element"/>
                    </xsl:call-template>
                <br/>
                </xsl:if>
		    </xsl:when>
			
			<xsl:when test="$page-type = 'package-design'">
                <xsl:if test="((not($single-package = 'true')) and ($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/package-oo-metrics/distance)) or
                                    (($single-package = 'true') and ($package-element/statistics/package-oo-metrics/distance))">
                    <xsl:call-template name="standard-analysis-package-design">
                       <xsl:with-param name="reports-element" select="$reports-element"/>
                       <xsl:with-param name="packages-element" select="$packages-element"/>
                       <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                       <xsl:with-param name="single-package" select="$single-package"/>
                       <xsl:with-param name="package-element" select="$package-element"/>
                    </xsl:call-template>
                <br/>
                </xsl:if>
		    </xsl:when>

  	        <xsl:when test="$page-type = 'code'">
                <xsl:if test="((not($single-package = 'true')) and ($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/source-metrics/ncss)) or
							(($single-package = 'true') and ($package-element/statistics/source-metrics/ncss))">
                    <xsl:call-template name="standard-analysis-size">
                       <xsl:with-param name="reports-element" select="$reports-element"/>
                       <xsl:with-param name="packages-element" select="$packages-element"/>
                       <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                       <xsl:with-param name="single-package" select="$single-package"/>
                       <xsl:with-param name="package-element" select="$package-element"/>
                    </xsl:call-template>

                <br/>
                    <xsl:call-template name="standard-analysis-code-quality">
                       <xsl:with-param name="reports-element" select="$reports-element"/>
                       <xsl:with-param name="packages-element" select="$packages-element"/>
                       <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                       <xsl:with-param name="single-package" select="$single-package"/>
                       <xsl:with-param name="package-element" select="$package-element"/>
                    </xsl:call-template>
                <br/>
                    <xsl:call-template name="standard-analysis-documentation">
                       <xsl:with-param name="reports-element" select="$reports-element"/>
                       <xsl:with-param name="packages-element" select="$packages-element"/>
                       <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                       <xsl:with-param name="single-package" select="$single-package"/>
                       <xsl:with-param name="package-element" select="$package-element"/>
                    </xsl:call-template>
                </xsl:if>
            </xsl:when>

            <xsl:when test="$page-type = 'test'">
                <xsl:if test="((not($single-package = 'true')) and ($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/test-metrics)) or
                                    (($single-package = 'true') and ($package-element/statistics/test-metrics))">
                    <xsl:call-template name="standard-analysis-test">
                       <xsl:with-param name="reports-element" select="$reports-element"/>
                       <xsl:with-param name="packages-element" select="$packages-element"/>
                       <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                       <xsl:with-param name="single-package" select="$single-package"/>
                       <xsl:with-param name="package-element" select="$package-element"/>
                    </xsl:call-template>
                </xsl:if>
            </xsl:when>

            <xsl:when test="$page-type = 'source control'">
                <xsl:if test="((not($single-package = 'true')) and ($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/source-control-metrics)) or
                                    (($single-package = 'true') and ($package-element/statistics/source-control-metrics))">

                    <xsl:call-template name="standard-analysis-source-control">
                        <xsl:with-param name="reports-element" select="$reports-element"/>
                        <xsl:with-param name="packages-element" select="$packages-element"/>
                        <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                        <xsl:with-param name="single-package" select="$single-package"/>
                        <xsl:with-param name="package-element" select="$package-element"/>
                    </xsl:call-template>

                </xsl:if>
            </xsl:when>



            <xsl:when test="$page-type = 'system specific'">
                <xsl:call-template name="system-specific-analysis">
                       <xsl:with-param name="reports-element" select="$reports-element"/>
                       <xsl:with-param name="packages-element" select="$packages-element"/>
                       <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                       <xsl:with-param name="single-package" select="$single-package"/>
                       <xsl:with-param name="package-element" select="$package-element"/>
                </xsl:call-template>
            </xsl:when>

        </xsl:choose>
      </body>
   </html>
   	
</xsl:template>






</xsl:stylesheet>
