<?xml version="1.0" encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects.
======================================================================= -->
<xsl:stylesheet  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:lxslt="http://xml.apache.org/xslt"
  xmlns:xalan="http://xml.apache.org/xalan">


<!-- Page HEADER -->
<xsl:template name="page-header">
	<xsl:param name="main-menu-page-name"/>
	<xsl:param name="page-name"/>
	<xsl:param name="dynamics-page-name" select="'overview'"/>
	<xsl:param name="path-to-root"/>
	<xsl:param name="subsystem-name" select="''"/>
	<xsl:param name="package-name" select="''"/>
	<xsl:param name="test-enabled"/>
	<xsl:variable name="dynamics-url">
	  <xsl:choose>
	      <xsl:when test="$subsystem-name != ''"><xsl:value-of select="concat($dynamics-root,'/subsystems/',$dynamics-page-name,'-subsystem-',$subsystem-name,'.html')"/></xsl:when>
	      <xsl:when test="$package-name != ''"><xsl:value-of select="concat($dynamics-root,'/packages/',$dynamics-page-name,'-package-',$package-name,'.html')"/></xsl:when>
	      <xsl:otherwise><xsl:value-of select="concat($dynamics-root,'/subsystems/',$dynamics-page-name,'-system.html')"/></xsl:otherwise>
	  </xsl:choose>
	</xsl:variable>

  <table width="100%">
    <tr>

        <td valign="top" align="left">
            <!--h1>Statics<xsl:if test="$dynamics-configured = 'true'"> / <a href="{$dynamics-url}">Dynamics</a></xsl:if></h1-->
        </td>
        <td align="right" rowspan="2">
            <img src="{$path-to-root}img/xradar-basic-sign.jpg"/>
        </td>
    </tr>
    <tr>
        <td valign="bottom" align="left">
            <h1><a href="http://xradar.sourceforge.net">http://xradar.sourceforge.net</a></h1>
        </td>
    </tr>
  </table>
  <hr size="1"/>
  <table width="100%">
	  <tr>
	    	<td align="left">
		    	<b>
		    	Statics Report -
		    	System: <xsl:value-of select="/IntegratedAnalysis/@system"/>,
		    	Version: <xsl:value-of select="/IntegratedAnalysis/@version"/>,
		    	Date: <xsl:value-of select="/IntegratedAnalysis/@date"/></b>
	    	</td>
	      	<td align="right">Designed for use with
		      <xsl:for-each select="/IntegratedAnalysis/source">
				<xsl:sort select="."/>
				<!--
				<xsl:message>
				link:<xsl:value-of select="@link"/>
				</xsl:message>  -->
		      	<a target="_new">
		      		<xsl:attribute name="href">
		      			<xsl:value-of select="@link"/>
		      		</xsl:attribute>
		      		<xsl:value-of select="."/>
		      	</a>,
		      </xsl:for-each>
              <a href="http://www.java2html.de/" target="_new">Java2HTML</a>
		      and
		      <a href="http://ant.apache.org" target="_new">Ant</a>.
	      	</td>
	  </tr>
  </table>
  <hr size="1"/>
    <table width="100%">
        <tr>
            <td colspan="2">
                <h2>
                    [Statics] <xsl:value-of select="$page-name"/>
                </h2>
            </td>
        </tr>
        <tr>
            <td></td>
            <td align="right">
                <b>
                    <xsl:call-template name="main-menu">
                        <xsl:with-param name="main-menu-page-name" select="$main-menu-page-name"/>
                        <xsl:with-param name="page-name" select="$page-name"/>
                        <xsl:with-param name="path-to-root" select="$path-to-root"/>
                    </xsl:call-template>
                </b>
            </td>
        </tr>
        <tr>
            <td></td>
            <td align="right">
                <xsl:if test="string-length($main-menu-page-name) &gt; 0">
                    <xsl:call-template name="sub-menu">
                        <xsl:with-param name="main-menu-page-name" 	select="$main-menu-page-name"/>
                        <xsl:with-param name="page-name" 			select="$page-name"/>
                        <xsl:with-param name="path-to-root" 		select="$path-to-root"/>
                    	<xsl:with-param name="test-enabled"			select="$test-enabled"/>
                    </xsl:call-template>
                </xsl:if>
            </td>
        </tr>
    </table>
   <hr size="1"/>
</xsl:template>



<!-- Main menu -->
<xsl:template name="main-menu">
    <xsl:param name="main-menu-page-name"/>
    <xsl:param name="page-name"/>
    <xsl:param name="frame-target"/>
    <xsl:param name="path-to-root"/>
      <xsl:choose>
        <xsl:when test="$main-menu-page-name = 'scorecard'">
            [scorecard]
        </xsl:when>
        <xsl:otherwise>
            [<a>
                <xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'scorecard-overview.html')"/></xsl:attribute>
                <xsl:if test="$frame-target='true'">
                    <xsl:attribute name="target">classFrame</xsl:attribute>
                </xsl:if>scorecard</a>]
        </xsl:otherwise>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="$main-menu-page-name = 'analysis'">
            [analysis]
        </xsl:when>
        <xsl:otherwise>
            [<a>
                <xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'analysis/package-by-name.html')"/></xsl:attribute>
                <xsl:if test="$frame-target='true'">
                    <xsl:attribute name="target">classFrame</xsl:attribute>
                </xsl:if>analysis</a>]
        </xsl:otherwise>
      </xsl:choose>


      <xsl:choose>
        <xsl:when test="$main-menu-page-name = 'explanations'">
            [explanations]
        </xsl:when>
        <xsl:otherwise>
            [<a>
                <xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'overview-explanations.html')"/></xsl:attribute>
                <xsl:if test="$frame-target='true'">
                    <xsl:attribute name="target">classFrame</xsl:attribute>
                </xsl:if>explanations</a>]
        </xsl:otherwise>
      </xsl:choose>

</xsl:template>



<!-- Sub menu -->
<xsl:template name="sub-menu">
  <xsl:param name="main-menu-page-name"/>
  <xsl:param name="page-name"/>
  <xsl:param name="frame-target"/>
  <xsl:param name="path-to-root"/>
  <xsl:param name="test-enabled"/>

  <xsl:if test="$main-menu-page-name='scorecard'">
	  <xsl:choose>
	  	<xsl:when test="$page-name = 'overview'">
	  		{overview}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'scorecard-overview.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>overview</a>}
	  	</xsl:otherwise>
	  </xsl:choose>
      <xsl:choose>
	  	<xsl:when test="$page-name = 'architecture'">
	  		{architecture}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'scorecard-architecture.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>architecture</a>}
	  	</xsl:otherwise>
	  </xsl:choose>
	  <xsl:choose>
	  	<xsl:when test="$page-name = 'package design'">
	  		{design}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'scorecard-package-design.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>design</a>}
	  	</xsl:otherwise>
	  </xsl:choose>

	  <xsl:choose>
	  	<xsl:when test="$page-name = 'code'">
	  		{code}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'scorecard-code.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>code</a>}
	  	</xsl:otherwise>
	  </xsl:choose>


  	  <xsl:choose>

	  	<xsl:when test="($page-name = 'test') and ($test-enabled = 'true')">
	  		{test}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'scorecard-test.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>test</a>}
	  	</xsl:otherwise>
	  </xsl:choose>
      <xsl:choose>
          <xsl:when test="$page-name = 'source-control'">
              {source control}
          </xsl:when>
          <xsl:otherwise>
              {<a>
                  <xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'scorecard-source-control.html')"/></xsl:attribute>
                  <xsl:if test="$frame-target='true'">
                      <xsl:attribute name="target">classFrame</xsl:attribute>
                  </xsl:if>source control</a>}
          </xsl:otherwise>
      </xsl:choose>
	  <xsl:choose>
	  	<xsl:when test="$page-name = 'system specific'">
	  		{system specific}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'scorecard-system-specific.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>system specific</a>}
	  	</xsl:otherwise>
	  </xsl:choose>
  </xsl:if>


  <xsl:if test="$main-menu-page-name='analysis'">
	<xsl:choose>
	  	<xsl:when test="$page-name = 'package analysis'">
	  		{package analysis}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'analysis/package-by-name.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>package analysis</a>}
	  	</xsl:otherwise>
	</xsl:choose>
	<xsl:choose>
	  	<xsl:when test="$page-name = 'class analysis'">
	  		{class analysis}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'analysis/class-by-package.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>class analysis</a>}
	  	</xsl:otherwise>
	</xsl:choose>
    <xsl:choose>
	  	<xsl:when test="$page-name = 'method analysis'">
	  		{method analysis}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'analysis/class-methods-by-package.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>method analysis</a>}
	  	</xsl:otherwise>
	</xsl:choose>

	<xsl:choose>
	  	<xsl:when test="$page-name = 'redundant code analysis'">
	  		{redundant&#160;code}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'overview-unused-code-analysis.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>redundant&#160;code</a>}
	  	</xsl:otherwise>
	</xsl:choose>


	<xsl:choose>
	  	<xsl:when test="$page-name = 'external packages analysis'">
	  		{external&#160;packages}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'overview-external-packages-analysis.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>external&#160;packages</a>}
	  	</xsl:otherwise>
	</xsl:choose>

	<!-- David Stokar -->	
	<xsl:choose>
	  	<xsl:when test="$page-name = 'languages used analysis'">
	  		{languages&#160;used}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'overview-languages-used-analysis.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>languages&#160;used</a>}
	  	</xsl:otherwise>
	</xsl:choose>	
	<!-- End David Stokar -->

	<xsl:choose>
	  	<xsl:when test="$page-name = 'system specific analysis'">
	  		{system&#160;specific&#160;analysis}
	  	</xsl:when>
	  	<xsl:otherwise>
	  		{<a>
	  			<xsl:attribute name="href"><xsl:value-of select="concat($path-to-root,'overview-system-specific-analysis.html')"/></xsl:attribute>
	  			<xsl:if test="$frame-target='true'">
	  				<xsl:attribute name="target">classFrame</xsl:attribute>
	  			</xsl:if>system&#160;specific&#160;analysis</a>}
	  	</xsl:otherwise>
	</xsl:choose>

  </xsl:if>


</xsl:template>

<xsl:template name="create-subsystems-with-packages">
	<xsl:param name="radar-config"/>
	<xsl:param name="packages-element"/>
	<xsl:param name="include-stats"/>
	<xsl:param name="include-cycles"/>
	<xsl:param name="include-depends-upon"/>
	<xsl:param name="include-components"/>

	<xsl:variable name="rtf-packages-in-subsystems">
		<xsl:call-template name="classified-packages-in-subsystems">
			<xsl:with-param name="radar-config" select="$radar-config"/>
			<xsl:with-param name="packages-element" select="$packages-element"/>
			<xsl:with-param name="include-stats" select="$include-stats"/>
			<xsl:with-param name="include-cycles" select="$include-cycles"/>
			<xsl:with-param name="include-depends-upon" select="$include-depends-upon"/>
			<xsl:with-param name="include-components" select="$include-components"/>
		</xsl:call-template>
	</xsl:variable>


	<xsl:variable name="rtf-packages-not-in-subsystems">
		<xsl:call-template name="non-classified-packages-in-subsystems">
			<xsl:with-param name="radar-config" select="$radar-config"/>
			<xsl:with-param name="packages-element" select="$packages-element"/>
			<xsl:with-param name="include-stats" select="$include-stats"/>
			<xsl:with-param name="include-cycles" select="$include-cycles"/>
			<xsl:with-param name="include-depends-upon" select="$include-depends-upon"/>
			<xsl:with-param name="include-components" select="$include-components"/>
		</xsl:call-template>
	</xsl:variable>

	<xsl:copy-of select="xalan:nodeset($rtf-packages-in-subsystems)"/>
	<xsl:copy-of select="xalan:nodeset($rtf-packages-not-in-subsystems)"/>

</xsl:template>


<xsl:template name="classified-packages-in-subsystems">
	<xsl:param name="radar-config"/>
	<xsl:param name="packages-element"/>
	<xsl:param name="include-stats"/>
	<xsl:param name="include-cycles"/>
	<xsl:param name="include-depends-upon"/>
	<xsl:param name="include-components"/>

	<xsl:for-each select="$radar-config/radar-config/subsystems/subsystem">
		<subsystem>
			<xsl:attribute name="name">
				<xsl:value-of select="normalize-space(name)"/>
			</xsl:attribute>
			<xsl:variable name="included-packages" select="included-packages"/>
			<xsl:for-each select="included-packages/package-root">
				<xsl:variable name="package-root" select="@value"/>
				<xsl:for-each select="$packages-element/Package[starts-with(@name, $package-root)]">
					<xsl:copy>
						<xsl:attribute name="name">
							<xsl:value-of select="@name"/>
						</xsl:attribute>
						<xsl:if test="$include-stats='true'">
							<xsl:copy-of select="Stats"/>
						</xsl:if>
						<xsl:if test="$include-cycles='true'">
							<xsl:copy-of select="Cycles"/>
						</xsl:if>
						<xsl:if test="$include-depends-upon='true'">
							<xsl:copy-of select="DependsUpon"/>
						</xsl:if>
						<xsl:if test="$include-components='true'">
							<xsl:copy-of select="components"/>
						</xsl:if>
					</xsl:copy>
				</xsl:for-each>
			</xsl:for-each>
		</subsystem>
	</xsl:for-each>
</xsl:template>

<xsl:template name="non-classified-packages-in-subsystems">
	<xsl:param name="radar-config"/>
	<xsl:param name="packages-element"/>
	<xsl:param name="include-stats"/>
	<xsl:param name="include-cycles"/>
	<xsl:param name="include-depends-upon"/>
	<xsl:param name="include-components"/>

	<xsl:variable name="rtf-included-packages">
		<xsl:for-each select="$radar-config/radar-config/subsystems/subsystem/included-packages/package-root">
				<xsl:copy-of select="current()"/>
		</xsl:for-each>
    </xsl:variable>
	<xsl:variable name="included-packages" select="xalan:nodeset($rtf-included-packages)"/>
	<xsl:variable name="package-root-element" select="count(xalan:nodeset($rtf-included-packages)/package-root)"/>

	<subsystem name="Not Classified">
		<xsl:for-each select="$packages-element/Package[Stats]">
			<xsl:variable name="in-classifications">
				<xsl:call-template name="true-if-in-classifications">
					<xsl:with-param name="package-name" select="@name"/>
					<xsl:with-param name="included-packages" select="$included-packages"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:if test="not(contains($in-classifications,'true'))">
				<xsl:copy>
					<xsl:attribute name="name">
						<xsl:value-of select="@name"/>
					</xsl:attribute>
					<xsl:if test="$include-stats='true'">
						<xsl:copy-of select="Stats"/>
					</xsl:if>
					<xsl:if test="$include-cycles='true'">
						<xsl:copy-of select="Cycles"/>
					</xsl:if>
					<xsl:if test="$include-depends-upon='true'">
						<xsl:copy-of select="DependsUpon"/>
					</xsl:if>
					<xsl:if test="$include-components='true'">
						<xsl:copy-of select="components"/>
					</xsl:if>
				</xsl:copy>
			</xsl:if>
		</xsl:for-each>
	</subsystem>
</xsl:template>


<xsl:template name="true-if-in-classifications">
	<xsl:param name="package-name"/>
	<xsl:param name="included-packages"/>

	<xsl:variable name="in-classifications">
		<xsl:for-each select="$included-packages/package-root">
			<xsl:if test="starts-with($package-name, @value)">
				true
			</xsl:if>
		</xsl:for-each>
	</xsl:variable>

	<xsl:if test="contains($in-classifications,'true')">
		<xsl:value-of select="'true'"/>
	</xsl:if>
</xsl:template>


<xsl:template name="split-string-with-string">
	<xsl:param name="string"/>
	<xsl:param name="substring-length"/>
	<xsl:param name="split-string"/>

	<xsl:value-of select="substring($string,1,$substring-length)"/>

	<xsl:if test="string-length($string) &gt; $substring-length">
        <xsl:value-of select="$split-string"/>
		<xsl:call-template name="split-string-with-string">
			<xsl:with-param name="string" select="substring($string,$substring-length + 1,string-length($string))"/>
			<xsl:with-param name="substring-length" select="$substring-length"/>
            <xsl:with-param name="split-string" select="$split-string"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>


</xsl:stylesheet>
